//============================================================================
// CFAH_WinTestDlg.cpp
// MS Visual C++ 6.0
// Copyright 2002, Crystalfontz America, Inc. Written by Brent A. Crosby
// www.crystalfontz.com, brent@crystalfontz.com
//============================================================================

#include "stdafx.h"
#include "CFAH_WinTest.h"
#include "CFAH_WinTestDlg.h"

//Parallel port direct access stuff
#include "dlportio.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
//Comments from the old DOS version
//LPT1
#define port0 0x378
//LPT2
//#define port0 0x278
//Monochrome printer adaptor parallel port
//#define port0 0x3BC
#define port1 (port0+1)
#define port2 (port0+2)
//
// Here are pinouts:
//
// PC  PC           Port  LCD
// Pin Name         .bit  Function
//
// 1   Strobe       2.0   E0
// 14  /AutoFeed    2.1   R/W
// 16  Init         2.2   RS
// 17  SelectIn     2.3   E1
//
// 2   Data0        0.0   D0
// 3   Data1        0.1   D1
// 4   Data2        0.2   D2
// 5   Data3        0.3   D3
// 6   Data4        0.4   D4
// 7   Data5        0.5   D5
// 8   Data6        0.6   D6
// 9   Data7        0.7   D7
//
// Additional inputs available:
//
// PC  PC           Port
// Pin Name         .bit
//
// 15  Error        1.3
// 13  Select       1.4
// 10  ACK          1.6
// 11  BUSY         1.7
//
// Additional outputs available:
//
// PC  PC           Port
// Pin Name         .bit
//
// 12  PaperEmpty   1.5
//
// 18  Ground
// 19-25 Ground
//
// You should leave port2.4 clear to keep the interrupt disabled.
/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCFAH_WinTestDlg dialog

CCFAH_WinTestDlg::CCFAH_WinTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCFAH_WinTestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCFAH_WinTestDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CCFAH_WinTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCFAH_WinTestDlg)
	DDX_Control(pDX, IDC_DATA_HEX, m_data_hex);
	DDX_Control(pDX, IDC_DATA_DEC, m_data_dec);
	DDX_Control(pDX, IDC_DATA_ASCII, m_data_ascii);
	DDX_Control(pDX, IDC_D0_L, m_d0_l);
	DDX_Control(pDX, IDC_D0_H, m_d0_h);
	DDX_Control(pDX, IDC_D1_L, m_d1_l);
	DDX_Control(pDX, IDC_D1_H, m_d1_h);
	DDX_Control(pDX, IDC_D2_L, m_d2_l);
	DDX_Control(pDX, IDC_D2_H, m_d2_h);
	DDX_Control(pDX, IDC_D3_L, m_d3_l);
	DDX_Control(pDX, IDC_D3_H, m_d3_h);
	DDX_Control(pDX, IDC_D4_L, m_d4_l);
	DDX_Control(pDX, IDC_D4_H, m_d4_h);
	DDX_Control(pDX, IDC_D5_L, m_d5_l);
	DDX_Control(pDX, IDC_D5_H, m_d5_h);
	DDX_Control(pDX, IDC_D6_L, m_d6_l);
	DDX_Control(pDX, IDC_D6_H, m_d6_h);
	DDX_Control(pDX, IDC_D7_L, m_d7_l);
	DDX_Control(pDX, IDC_D7_H, m_d7_h);
	DDX_Control(pDX, IDC_RW_L, m_rw_l);
	DDX_Control(pDX, IDC_RW_H, m_rw_h);
	DDX_Control(pDX, IDC_RS_L, m_rs_l);
	DDX_Control(pDX, IDC_RS_H, m_rs_h);
	DDX_Control(pDX, IDC_E1_L, m_e1_l);
	DDX_Control(pDX, IDC_E1_H, m_e1_h);
	DDX_Control(pDX, IDC_E0_L, m_e0_l);
	DDX_Control(pDX, IDC_E0_H, m_e0_h);
	DDX_Control(pDX, IDC_Display_Type, m_display_type);
	DDX_Control(pDX, IDC_Address, m_address);
	DDX_Control(pDX, IDC_Line_3, m_line_3);
	DDX_Control(pDX, IDC_Line_2, m_line_2);
	DDX_Control(pDX, IDC_Line_1, m_line_1);
	DDX_Control(pDX, IDC_Line_0, m_line_0);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCFAH_WinTestDlg, CDialog)
	//{{AFX_MSG_MAP(CCFAH_WinTestDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(ID_Init_4_Bit, OnInit4Bit)
	ON_BN_CLICKED(ID_Init_8_Bit, OnInit8Bit)
	ON_CBN_CLOSEUP(IDC_Display_Type, OnCloseupDisplayType)
	ON_BN_CLICKED(IDC_D0_H, OnD0H)
	ON_BN_CLICKED(IDC_D0_L, OnD0L)
	ON_BN_CLICKED(IDC_D1_H, OnD1H)
	ON_BN_CLICKED(IDC_D1_L, OnD1L)
	ON_BN_CLICKED(IDC_D2_H, OnD2H)
	ON_BN_CLICKED(IDC_D2_L, OnD2L)
	ON_BN_CLICKED(IDC_D3_H, OnD3H)
	ON_BN_CLICKED(IDC_D3_L, OnD3L)
	ON_BN_CLICKED(IDC_D4_H, OnD4H)
	ON_BN_CLICKED(IDC_D4_L, OnD4L)
	ON_BN_CLICKED(IDC_D5_H, OnD5H)
	ON_BN_CLICKED(IDC_D5_L, OnD5L)
	ON_BN_CLICKED(IDC_D6_H, OnD6H)
	ON_BN_CLICKED(IDC_D6_L, OnD6L)
	ON_BN_CLICKED(IDC_D7_H, OnD7H)
	ON_BN_CLICKED(IDC_D7_L, OnD7L)
	ON_BN_CLICKED(IDC_E0_H, OnE0H)
	ON_BN_CLICKED(IDC_E0_L, OnE0L)
	ON_BN_CLICKED(IDC_E1_H, OnE1H)
	ON_BN_CLICKED(IDC_E1_L, OnE1L)
	ON_BN_CLICKED(IDC_RS_H, OnRsH)
	ON_BN_CLICKED(IDC_RS_L, OnRsL)
	ON_BN_CLICKED(IDC_RW_H, OnRwH)
	ON_BN_CLICKED(IDC_RW_L, OnRwL)
	ON_CBN_CLOSEUP(IDC_Address, OnCloseupAddress)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////


#define DISPLAY_TYPE_8x2  0
#define DISPLAY_TYPE_12x2 1
#define DISPLAY_TYPE_16x1 2
#define DISPLAY_TYPE_16x2 3
#define DISPLAY_TYPE_20x2 4
#define DISPLAY_TYPE_24x2 5
#define DISPLAY_TYPE_16x4 6
#define DISPLAY_TYPE_20x4 7
#define DISPLAY_TYPE_40x2 8
#define DISPLAY_TYPE_40x4 9


#define PORT_ADDRESS_0x378 0
#define PORT_ADDRESS_0x278 1
#define PORT_ADDRESS_0x3BC 2

unsigned char
  data_register;
unsigned char
  control_register;
int
  port_data_address; //0 => 0x378, 1 => 0x278. 2 => 0x3BC
int
  port_control_address; //port_data_address + 2

/////////////////////////////////////////////////////////////////////////////
void CCFAH_WinTestDlg::Update_Buttons_From_Data_Register()
  {
  if(data_register&0x01)
    {
    m_d0_h.SetCheck(1);
    m_d0_l.SetCheck(0);
    }
  else
    {
    m_d0_h.SetCheck(0);
    m_d0_l.SetCheck(1);
    }
  if(data_register&0x02)
    {
    m_d1_h.SetCheck(1);
    m_d1_l.SetCheck(0);
    }
  else
    {
    m_d1_h.SetCheck(0);
    m_d1_l.SetCheck(1);
    }
  if(data_register&0x04)
    {
    m_d2_h.SetCheck(1);
    m_d2_l.SetCheck(0);
    }
  else
    {
    m_d2_h.SetCheck(0);
    m_d2_l.SetCheck(1);
    }
  if(data_register&0x08)
    {
    m_d3_h.SetCheck(1);
    m_d3_l.SetCheck(0);
    }
  else
    {
    m_d3_h.SetCheck(0);
    m_d3_l.SetCheck(1);
    }
  if(data_register&0x10)
    {
    m_d4_h.SetCheck(1);
    m_d4_l.SetCheck(0);
    }
  else
    {
    m_d4_h.SetCheck(0);
    m_d4_l.SetCheck(1);
    }
  if(data_register&0x20)
    {
    m_d5_h.SetCheck(1);
    m_d5_l.SetCheck(0);
    }
  else
    {
    m_d5_h.SetCheck(0);
    m_d5_l.SetCheck(1);
    }
  if(data_register&0x40)
    {
    m_d6_h.SetCheck(1);
    m_d6_l.SetCheck(0);
    }
  else
    {
    m_d6_h.SetCheck(0);
    m_d6_l.SetCheck(1);
    }
  if(data_register&0x80)
    {
    m_d7_h.SetCheck(1);
    m_d7_l.SetCheck(0);
    }
  else
    {
    m_d7_h.SetCheck(0);
    m_d7_l.SetCheck(1);
    }
  char
    string[20];
  sprintf(string,"%d",data_register);
  m_data_dec.SetWindowText(string);
  m_data_dec.UpdateWindow();
  sprintf(string,"0x%02X",data_register);
  m_data_hex.SetWindowText(string);
  m_data_hex.UpdateWindow();
  if(isprint(data_register))
    sprintf(string,"\'%c\'",data_register);
  else   
    sprintf(string,"");
  m_data_ascii.SetWindowText(string);
  m_data_ascii.UpdateWindow();

  //Now update the physical port.
  DlPortWritePortUchar(port_data_address,data_register);
  }
/////////////////////////////////////////////////////////////////////////////
void CCFAH_WinTestDlg::Update_Buttons_From_Control_Register()
  {
  // 1   Strobe       2.0   E0
  // 14  /AutoFeed    2.1   R/W
  // 16  Init         2.2   RS
  // 17  SelectIn     2.3   E1
  if(control_register&0x01)
    {
    m_e0_h.SetCheck(1);
    m_e0_l.SetCheck(0);
    }
  else
    {
    m_e0_h.SetCheck(0);
    m_e0_l.SetCheck(1);
    }
  if(control_register&0x02)
    {
    m_rw_h.SetCheck(1);
    m_rw_l.SetCheck(0);
    }
  else
    {
    m_rw_h.SetCheck(0);
    m_rw_l.SetCheck(1);
    }
  if(control_register&0x04)
    {
    m_rs_h.SetCheck(1);
    m_rs_l.SetCheck(0);
    }
  else
    {
    m_rs_h.SetCheck(0);
    m_rs_l.SetCheck(1);
    }
  if(control_register&0x08)
    {
    m_e1_h.SetCheck(1);
    m_e1_l.SetCheck(0);
    }
  else
    {
    m_e1_h.SetCheck(0);
    m_e1_l.SetCheck(1);
    }
  //Now update the physical port.
  DlPortWritePortUchar(port_control_address,control_register^0x03);
  }
/////////////////////////////////////////////////////////////////////////////
// CCFAH_WinTestDlg message handlers
BOOL CCFAH_WinTestDlg::OnInitDialog()
  {
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
  	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
	  	{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		  }
	  }

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

  //Set the font of the LCD lines to fixed-pitch
  HFONT
    m_hFont;
  CFont
    *m_pFont;
  m_hFont = (HFONT)GetStockObject(ANSI_FIXED_FONT);
  m_pFont = CFont::FromHandle (m_hFont);
  m_line_0.SetFont (m_pFont);
  m_line_1.SetFont (m_pFont);
  m_line_2.SetFont (m_pFont);
  m_line_3.SetFont (m_pFont);

	m_address.SetCurSel(PORT_ADDRESS_0x378);
  OnCloseupAddress();
  data_register=0;
  Update_Buttons_From_Data_Register();
  control_register=0;
  Update_Buttons_From_Control_Register();

	m_display_type.SetCurSel(DISPLAY_TYPE_16x2),
  OnCloseupDisplayType();
	
	return TRUE;  // return TRUE  unless you set the focus to a control
  }
/////////////////////////////////////////////////////////////////////////////
void CCFAH_WinTestDlg::OnSysCommand(UINT nID, LPARAM lParam)
  {
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	  {
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	  }
	else
		CDialog::OnSysCommand(nID, lParam);
  }
/////////////////////////////////////////////////////////////////////////////
void CCFAH_WinTestDlg::OnPaint() 
  {
	if (IsIconic())
	  {
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	  }
	else
		CDialog::OnPaint();
  }
/////////////////////////////////////////////////////////////////////////////
HCURSOR CCFAH_WinTestDlg::OnQueryDragIcon()
  {
	return (HCURSOR) m_hIcon;
  }
/////////////////////////////////////////////////////////////////////////////
void CCFAH_WinTestDlg::OnCloseupDisplayType() 
	{
	switch(m_display_type.GetCurSel())
    {
    case DISPLAY_TYPE_8x2:  //01234567
      m_line_0.SetWindowText("CFAH0802");
      m_line_1.SetWindowText("* 8x2  *");
      m_line_1.SetReadOnly(0);
      m_line_2.SetWindowText("");
      m_line_2.SetReadOnly(1);
      m_line_3.SetWindowText("");
      m_line_3.SetReadOnly(1);
      m_e1_l.EnableWindow(FALSE);
      m_e1_h.EnableWindow(FALSE);
      break;
    case DISPLAY_TYPE_12x2: //012345678901
      m_line_0.SetWindowText("* CFAH1202 *");
      m_line_1.SetWindowText("*** 12x2 ***");
      m_line_1.SetReadOnly(0);
      m_line_2.SetWindowText("");
      m_line_2.SetReadOnly(1);
      m_line_3.SetWindowText("");
      m_line_3.SetReadOnly(1);
      m_e1_l.EnableWindow(FALSE);
      m_e1_h.EnableWindow(FALSE);
      break;
    case DISPLAY_TYPE_16x1: //0123456789012345
      m_line_0.SetWindowText("*CFAH-1601 16x1*");
      m_line_1.SetWindowText("");
      m_line_1.SetReadOnly(1);
      m_line_2.SetWindowText("");
      m_line_2.SetReadOnly(1);
      m_line_3.SetWindowText("");
      m_line_3.SetReadOnly(1);
      m_e1_l.EnableWindow(FALSE);
      m_e1_h.EnableWindow(FALSE);
      break;
    case DISPLAY_TYPE_16x2: //0123456789012345
      m_line_0.SetWindowText("*CFAH-1602 16x2*");
      m_line_1.SetWindowText("* Crystalfontz *");
      m_line_1.SetReadOnly(0);
      m_line_2.SetWindowText("");
      m_line_2.SetReadOnly(1);
      m_line_3.SetWindowText("");
      m_line_3.SetReadOnly(1);
      m_e1_l.EnableWindow(FALSE);
      m_e1_h.EnableWindow(FALSE);
      break;
    case DISPLAY_TYPE_20x2: //01234567890123456789
      m_line_0.SetWindowText("** CFAH-2002 20x2 **");
      m_line_1.SetWindowText("*** Crystalfontz ***");
      m_line_1.SetReadOnly(0);
      m_line_2.SetWindowText("");
      m_line_2.SetReadOnly(1);
      m_line_3.SetWindowText("");
      m_line_3.SetReadOnly(1);
      m_e1_l.EnableWindow(FALSE);
      m_e1_h.EnableWindow(FALSE);
      break;
    case DISPLAY_TYPE_24x2: //012345678901234567890123
      m_line_0.SetWindowText("**** CFAH-2402 24x2 ****");
      m_line_1.SetWindowText("* www.crystalfontz.com *");
      m_line_1.SetReadOnly(0);
      m_line_2.SetWindowText("");
      m_line_2.SetReadOnly(1);
      m_line_3.SetWindowText("");
      m_line_3.SetReadOnly(1);
      m_e1_l.EnableWindow(FALSE);
      m_e1_h.EnableWindow(FALSE);
      break;
    case DISPLAY_TYPE_16x4: //0123456789012345
      m_line_0.SetWindowText("*CFAH-1602 16x4*");
      m_line_1.SetWindowText("* Crystalfontz *");
      m_line_1.SetReadOnly(0);
      m_line_2.SetWindowText("abcdefghijklmnop");
      m_line_2.SetReadOnly(0);
      m_line_3.SetWindowText("ABCDEFGHIJKLMNOP");
      m_line_3.SetReadOnly(0);
      m_e1_l.EnableWindow(FALSE);
      m_e1_h.EnableWindow(FALSE);
      break;
    case DISPLAY_TYPE_20x4: //01234567890123455689
      m_line_0.SetWindowText("** CFAH-2002 20x4 **");
      m_line_1.SetWindowText("*** Crystalfontz ***");
      m_line_1.SetReadOnly(0);
      m_line_2.SetWindowText("abcdefghijklmnopqrst");
      m_line_2.SetReadOnly(0);
      m_line_3.SetWindowText("ABCDEFGHIJKLMNOPQRST");
      m_line_3.SetReadOnly(0);
      m_e1_l.EnableWindow(FALSE);
      m_e1_h.EnableWindow(FALSE);
      break;
    case DISPLAY_TYPE_40x2: //0123456789012345678901234567890123456789
      m_line_0.SetWindowText("* CFAH-4002 Forty Columns by Two Lines *");
      m_line_1.SetWindowText("** Crystalfontz America, Incorporated **");
      m_line_1.SetReadOnly(0);
      m_line_2.SetWindowText("");
      m_line_2.SetReadOnly(1);
      m_line_3.SetWindowText("");
      m_line_3.SetReadOnly(1);
      m_e1_l.EnableWindow(FALSE);
      m_e1_h.EnableWindow(FALSE);
      break;
    case DISPLAY_TYPE_40x4: //0123456789012345678901234567890123456789
      m_line_0.SetWindowText("*CFAH-4004: Forty Columns by Four Lines*");
      m_line_1.SetWindowText("** Crystalfontz America, Incorporated **");
      m_line_1.SetReadOnly(0);
      m_line_2.SetWindowText("abcdefghijklmnopqrstuvwzyz1234567890-=,.");
      m_line_2.SetReadOnly(0);
      m_line_3.SetWindowText("ABCDEFGNIJKLMNOPQRSTUVWXYZ!@#$%^&*()_+<>");
      m_line_3.SetReadOnly(0);
      m_e1_l.EnableWindow(TRUE);
      m_e1_h.EnableWindow(TRUE);
      break;
    }
	}
/////////////////////////////////////////////////////////////////////////////
void CCFAH_WinTestDlg::OnCloseupAddress() 
	{
  switch(m_address.GetCurSel())
    {
    case 1:
      port_data_address=0x278;
      break;
    case 2:
      port_data_address=0x3BC;
      break;
    default:
      port_data_address=0x378;
      break;
    }
  port_control_address=port_data_address+2;
	}
/////////////////////////////////////////////////////////////////////////////
void CCFAH_WinTestDlg::Write_LCD_Control_8(ubyte data,ubyte enable)
  {
  //Make register select 0, Make R/W 0=write
  OnRsL();
  OnRwL();
  //Write the data to the port.
  data_register=data;	
  Update_Buttons_From_Data_Register();
  //Strobe enable
  Sleep(1);
  if(enable)
    {
    OnE1H();
    Sleep(1);
    OnE1L();
    }
  else
    {
    OnE0H();
    Sleep(1);
    OnE0L();
    }
  }
/////////////////////////////////////////////////////////////////////////////
void CCFAH_WinTestDlg::Write_LCD_Data_8(ubyte data,ubyte enable)
  {
  //Make register select 1, Make R/W 0=write
  OnRsH();
  OnRwL();
  //Write the data to the port.
  data_register=data;	
  Update_Buttons_From_Data_Register();
  //Strobe enable
  Sleep(1);
  if(enable)
    {
    OnE1H();
    Sleep(1);
    OnE1L();
    }
  else
    {
    OnE0H();
    Sleep(1);
    OnE0L();
    }
  }
/////////////////////////////////////////////////////////////////////////////
void CCFAH_WinTestDlg::Write_LCD_Control_4(ubyte data,ubyte enable)
  {
  //Make register select 0, Make R/W 0=write
  OnRsL();
  OnRwL();
  //Apply the high 4 bits of data to the high four bits of the port.
  data_register=data&0xF0;
  Update_Buttons_From_Data_Register();
  //Strobe enable to clock in the high nibble.
  Sleep(1);
  if(enable)
    {
    OnE1H();
    Sleep(1);
    OnE1L();
    }
  else
    {
    OnE0H();
    Sleep(1);
    OnE0L();
    }
  //Apply the low 4 bits of data to the high four bits of the port.
  data_register=(data<<4)&0xF0;
  Update_Buttons_From_Data_Register();
  //Strobe enable to clock in the low nibble.
  Sleep(1);
  if(enable)
    {
    OnE1H();
    Sleep(1);
    OnE1L();
    }
  else
    {
    OnE0H();
    Sleep(1);
    OnE0L();
    }
  }
/////////////////////////////////////////////////////////////////////////////
void CCFAH_WinTestDlg::Write_LCD_Data_4(ubyte data,ubyte enable)
  {
  //Make register select 1, Make R/W 0=write
  OnRsH();
  OnRwL();
  //Apply the high 4 bits of data to the high four bits of the port.
  data_register=data&0xF0;
  Update_Buttons_From_Data_Register();
  //Strobe enable to clock in the high nibble.
  Sleep(1);
  if(enable)
    {
    OnE1H();
    Sleep(1);
    OnE1L();
    }
  else
    {
    OnE0H();
    Sleep(1);
    OnE0L();
    }
  //Apply the low 4 bits of data to the high four bits of the port.
  data_register=(data<<4)&0xF0;
  Update_Buttons_From_Data_Register();
  //Strobe enable to clock in the low nibble.
  Sleep(1);
  if(enable)
    {
    OnE1H();
    Sleep(1);
    OnE1L();
    }
  else
    {
    OnE0H();
    Sleep(1);
    OnE0L();
    }
  }
/////////////////////////////////////////////////////////////////////////////
void CCFAH_WinTestDlg::Init_LCD_8(ubyte enable)
  {
  //This sequence is from the initialization on page 45 of the HD44780U
  //data sheet.
  Sleep(40);
  Write_LCD_Control_8(0x38,enable);
  //Yes, the data sheet says write it twice.
  Sleep(5);
  Write_LCD_Control_8(0x38,enable);
  //Yes, the data sheet says write it three times.
  Sleep(125);
  Write_LCD_Control_8(0x38,enable);
  //Yes, the data sheet says write it four times, but at least this one counts.
  //038h is Function set:
  //8 bit,
  //2 line
  //F = (5x8)
  Sleep(1);
  Write_LCD_Control_8(0x38,enable);
  //"Display off"
  Sleep(2);
  Write_LCD_Control_8(0x08,enable);
  //"Display clear"
  Sleep(2);
  Write_LCD_Control_8(0x01,enable);
  //006h is Entry mode set, increment, no shift
	Sleep(2);
  Write_LCD_Control_8(0x06,enable);
  //Display on, cursor on, blinking
	Sleep(2);
  Write_LCD_Control_8(0x0F,enable);
  //Clear the display again. This seems to fix a power-up problem
  //where the display shows "{{{{{" in a couple of places.
	Sleep(2);
  Write_LCD_Control_8(0x01,enable);
  }
/////////////////////////////////////////////////////////////////////////////
void CCFAH_WinTestDlg::Init_LCD_4(ubyte enable)
  {
  //It is not an error that the first writes are "8-bit", see the HD44780
  //data sheet.
  //This sequence is from the initialization on page 46 of the HD44780U
  //data sheet.
  Sleep(40);
  Write_LCD_Control_8(0x30,enable);
  //Yes, the data sheet says write it twice.
  Sleep(5);
  Write_LCD_Control_8(0x30,enable);
  //Yes, the data sheet says write it three times.
  Sleep(125);
  Write_LCD_Control_8(0x30,enable);
  //Yes, the data sheet says write it four times, but at least this one counts.
  //020h is Function set:
  //4 bit,
  //2 line
  //F = (5x8)
  Sleep(1);
  //This is last 8-bit write, which is an instruction to put the LCD into 4-bit mode.
  Write_LCD_Control_8(0x20,enable);
  //Here is the 4-bit instruction to set the font and number of lines.
  Write_LCD_Control_4(0x28,enable);
  //"Display off"
  Sleep(2);
  Write_LCD_Control_4(0x08,enable);
  //"Display clear"
  Sleep(2);
  Write_LCD_Control_4(0x01,enable);
  //006h is Entry mode set, increment, no shift
	Sleep(2);
  Write_LCD_Control_4(0x06,enable);
  //Display on, cursor on, blinking
	Sleep(2);
  Write_LCD_Control_4(0x0F,enable);
  //Clear the display again. This seems to fix a power-up problem
  //where the display shows "{{{{{" in a couple of places.
	Sleep(2);
  Write_LCD_Control_4(0x01,enable);
  }
/////////////////////////////////////////////////////////////////////////////

typedef struct
  {
  ubyte cols;
  ubyte rows;
  ubyte controllers;
  ubyte line_address[4];
  } DISPLAY_PARAMS_STRUCT;

DISPLAY_PARAMS_STRUCT
  display_codes[10]=
    {
    { 8,2,1,{0x80,0xC0,0x00,0x00}}, //0: 8x2
    {12,2,1,{0x80,0xC0,0x00,0x00}}, //1: 12x2
    //16x1 is a special case: right half looks like second line of 8x2
    { 8,2,1,{0x80,0xC0,0x00,0x00}}, //2: 16x1 
    {16,2,1,{0x80,0xC0,0x00,0x00}}, //3: 16x2
    {20,2,1,{0x80,0xC0,0x00,0x00}}, //4: 20x2
    {24,2,1,{0x80,0xC0,0x00,0x00}}, //5: 24x2
    {16,4,1,{0x80,0xC0,0x90,0xD0}}, //5: 16x4
    {20,4,1,{0x80,0xC0,0x94,0xD4}}, //6: 20x4
    {40,2,1,{0x80,0xC0,0x00,0x00}}, //8: 40x2
    //40x4 is a special case: top half looks line 1st 40x2 bottom half
    //looks like 2nd 40x2
    {40,2,2,{0x80,0xC0,0x80,0xC0}}  //9: 40x4
    };

	static const char
    default_special_characters[8][8]=
      {
        { 0, 8,12,14,15,14,12, 8},  //right arrow
        { 0, 1, 3, 7,15, 7, 3, 1},  //left arrow
        { 0, 4, 4,14,14,31,31, 0},  //up arrow
        { 0,31,31,14,14, 4, 4, 0},  //down arrow
        { 0, 0,14,31,31,31,14, 0},  //circle
        { 4,10, 4, 7, 4, 6, 1, 1},  //sit
        { 4,10, 4,17,14, 4,10,17},  //dono
        {21,10,21,10,21,10,21,10}   //50%
      };
/////////////////////////////////////////////////////////////////////////////
void CCFAH_WinTestDlg::OnInit8Bit() 
  {
  int
    display_type;
  display_type=
    m_display_type.GetCurSel();

  ubyte
    i;
  ubyte
    j;

  ubyte
    controller;
  for(controller=0;
      controller<display_codes[display_type].controllers;
      controller++)
    {
    Init_LCD_8(controller);

    for(j=0;j<display_codes[display_type].rows;j++)
      {
      Sleep(2);
      Write_LCD_Control_8(display_codes[display_type].line_address[j],controller);

      //Get the string
      CString
        input_string;
      char
        string[120];
      switch(j+(controller*display_codes[display_type].rows))
        {
        case 0:
          m_line_0.GetWindowText(input_string);
      	  strcpy(string,(LPSTR)(const char *)input_string);
          break;
        case 1:
          if(display_type==DISPLAY_TYPE_16x1)
            {
            m_line_0.GetWindowText(input_string);
        	  strcpy(string,(LPSTR)(const char *)input_string);
            strcpy(string,&string[8]);
            }
          else
             {
             m_line_1.GetWindowText(input_string);
      	     strcpy(string,(LPSTR)(const char *)input_string);
             }
          break;
        case 2:
          m_line_2.GetWindowText(input_string);
      	  strcpy(string,(LPSTR)(const char *)input_string);
          break;
        case 3:
          m_line_3.GetWindowText(input_string);
      	  strcpy(string,(LPSTR)(const char *)input_string);
          break;
        }

      char
        send_string[120];
      for(i=0;i<=119;i++)
        send_string[i]=' ';
      //Copy the data, handling \123 and \\ and counting the characters
      int
        count;
      for(i=0,count=0;string[i]&&(count<display_codes[display_type].cols);i++,count++)
        {
        if((string[i]=='\\')&&(string[i+1]=='\\'))
          {
          send_string[count]='\\';
          i++;
          }
        else
          {
  		    if((string[i]=='\\')&&(isdigit(string[i+1]))
                              &&(isdigit(string[i+2]))
                              &&(isdigit(string[i+3]))
                              &&(((string[i+1]-'0')*100
                                   +(string[i+2]-'0')*10
                                   +(string[i+3]-'0'))<=255))
            {
            send_string[count]=
              ((string[i+1]-'0')*100+(string[i+2]-'0')*10+(string[i+3]-'0'));
            i+=3;
            }
          else
            send_string[count]=string[i];
          }
        }

      for(i=0;i<display_codes[display_type].cols;i++)
        {
        Sleep(2);
	      Write_LCD_Data_8(send_string[i],controller);
        }
      }
    //Initialize the 8 custom characters. Turn the cursor off.
    Sleep(2);
    Write_LCD_Control_8(0x0C,controller);
	  //Address the data area for the custom character 0.
    Sleep(2);
    Write_LCD_Control_8(0x40,controller);
    for(j=0;j<=7;j++)
      for(i=0;i<=7;i++)
        {
        Sleep(2);
	  	  Write_LCD_Data_8(default_special_characters[j][i],controller);
        }
    }

  //Idle things.
  data_register=0;
  Update_Buttons_From_Data_Register();
  control_register=0;
  Update_Buttons_From_Control_Register();	
  }
/////////////////////////////////////////////////////////////////////////////
void CCFAH_WinTestDlg::OnInit4Bit() 
  {
  int
    display_type;
  display_type=
    m_display_type.GetCurSel();

  ubyte
    i;
  ubyte
    j;

  ubyte
    controller;
  for(controller=0;
      controller<display_codes[display_type].controllers;
      controller++)
    {
    Init_LCD_4(controller);

    for(j=0;j<display_codes[display_type].rows;j++)
      {
      Sleep(2);
      Write_LCD_Control_4(display_codes[display_type].line_address[j],controller);

      //Get the string
      CString
        input_string;
      char
        string[120];
      switch(j+(controller*display_codes[display_type].rows))
        {
        case 0:
          m_line_0.GetWindowText(input_string);
      	  strcpy(string,(LPSTR)(const char *)input_string);
          break;
        case 1:
          if(display_type==DISPLAY_TYPE_16x1)
            {
            m_line_0.GetWindowText(input_string);
        	  strcpy(string,(LPSTR)(const char *)input_string);
            strcpy(string,&string[8]);
            }
          else
             {
             m_line_1.GetWindowText(input_string);
      	     strcpy(string,(LPSTR)(const char *)input_string);
             }
          break;
        case 2:
          m_line_2.GetWindowText(input_string);
      	  strcpy(string,(LPSTR)(const char *)input_string);
          break;
        case 3:
          m_line_3.GetWindowText(input_string);
      	  strcpy(string,(LPSTR)(const char *)input_string);
          break;
        }
      char
        send_string[120];
      for(i=0;i<=119;i++)
        send_string[i]=' ';
      //Copy the data, handling \123 and \\ and counting the characters
      int
        count;
      for(i=0,count=0;string[i]&&(count<display_codes[display_type].cols);i++,count++)
        {
        if((string[i]=='\\')&&(string[i+1]=='\\'))
          {
          send_string[count]='\\';
          i++;
          }
        else
          {
  		    if((string[i]=='\\')&&(isdigit(string[i+1]))
                              &&(isdigit(string[i+2]))
                              &&(isdigit(string[i+3]))
                              &&(((string[i+1]-'0')*100
                                   +(string[i+2]-'0')*10
                                   +(string[i+3]-'0'))<=255))
            {
            send_string[count]=
              ((string[i+1]-'0')*100+(string[i+2]-'0')*10+(string[i+3]-'0'));
            i+=3;
            }
          else
            send_string[count]=string[i];
          }
        }
      for(i=0;i<display_codes[display_type].cols;i++)
        {
        Sleep(2);
	      Write_LCD_Data_4(send_string[i],controller);
        }
      }

    //Initialize the 8 custom characters.Turn the cursor off.
    Sleep(2);
    Write_LCD_Control_4(0x0C,controller);
	  //Address the data area for the custom character 0.
    Sleep(2);
    Write_LCD_Control_4(0x40,controller);
    for(j=0;j<=7;j++)
      for(i=0;i<=7;i++)
        {
        Sleep(2);
	  	  Write_LCD_Data_4(default_special_characters[j][i],controller);
        }
    }

  //Idle things.
  data_register=0;
  Update_Buttons_From_Data_Register();
  control_register=0;
  Update_Buttons_From_Control_Register();	
  }
/////////////////////////////////////////////////////////////////////////////
void CCFAH_WinTestDlg::OnOK() 
  {
	CDialog::OnOK();
  }
/////////////////////////////////////////////////////////////////////////////
void CCFAH_WinTestDlg::OnD0H() 
  {
  data_register|=0x01;	
  Update_Buttons_From_Data_Register();
  }
/////////////////////////////////////////////////////////////////////////////
void CCFAH_WinTestDlg::OnD1H() 
  {
  data_register|=0x02;	
  Update_Buttons_From_Data_Register();
  }
/////////////////////////////////////////////////////////////////////////////
void CCFAH_WinTestDlg::OnD2H() 
  {
  data_register|=0x04;	
  Update_Buttons_From_Data_Register();
  }
/////////////////////////////////////////////////////////////////////////////
void CCFAH_WinTestDlg::OnD3H() 
  {
  data_register|=0x08;	
  Update_Buttons_From_Data_Register();
  }
/////////////////////////////////////////////////////////////////////////////
void CCFAH_WinTestDlg::OnD4H() 
  {
  data_register|=0x10;	
  Update_Buttons_From_Data_Register();
  }
/////////////////////////////////////////////////////////////////////////////
void CCFAH_WinTestDlg::OnD5H() 
  {
  data_register|=0x20;	
  Update_Buttons_From_Data_Register();
  }
/////////////////////////////////////////////////////////////////////////////
void CCFAH_WinTestDlg::OnD6H() 
  {
  data_register|=0x40;	
  Update_Buttons_From_Data_Register();
  }
/////////////////////////////////////////////////////////////////////////////
void CCFAH_WinTestDlg::OnD7H() 
  {
  data_register|=0x80;	
  Update_Buttons_From_Data_Register();
  }
/////////////////////////////////////////////////////////////////////////////
void CCFAH_WinTestDlg::OnD0L() 
  {
  data_register&=~0x01;	
  Update_Buttons_From_Data_Register();
  }
/////////////////////////////////////////////////////////////////////////////
void CCFAH_WinTestDlg::OnD1L() 
  {
  data_register&=~0x02;	
  Update_Buttons_From_Data_Register();
  }
/////////////////////////////////////////////////////////////////////////////
void CCFAH_WinTestDlg::OnD2L() 
  {
  data_register&=~0x04;	
  Update_Buttons_From_Data_Register();
  }
/////////////////////////////////////////////////////////////////////////////
void CCFAH_WinTestDlg::OnD3L() 
  {
  data_register&=~0x08;	
  Update_Buttons_From_Data_Register();
  }
/////////////////////////////////////////////////////////////////////////////
void CCFAH_WinTestDlg::OnD4L() 
  {
  data_register&=~0x10;	
  Update_Buttons_From_Data_Register();
  }
/////////////////////////////////////////////////////////////////////////////
void CCFAH_WinTestDlg::OnD5L() 
  {
  data_register&=~0x20;	
  Update_Buttons_From_Data_Register();
  }
/////////////////////////////////////////////////////////////////////////////
void CCFAH_WinTestDlg::OnD6L() 
  {
  data_register&=~0x40;	
  Update_Buttons_From_Data_Register();
  }
/////////////////////////////////////////////////////////////////////////////
void CCFAH_WinTestDlg::OnD7L() 
  {
  data_register&=~0x80;	
  Update_Buttons_From_Data_Register();
  }
/////////////////////////////////////////////////////////////////////////////
void CCFAH_WinTestDlg::OnE0H() 
  {
  control_register|=0x01;
  Update_Buttons_From_Control_Register();
  }
/////////////////////////////////////////////////////////////////////////////
void CCFAH_WinTestDlg::OnE0L() 
  {
  control_register&=~0x01;
  Update_Buttons_From_Control_Register();
  }
/////////////////////////////////////////////////////////////////////////////
void CCFAH_WinTestDlg::OnRwH() 
  {
  control_register|=0x02;
  Update_Buttons_From_Control_Register();
  }
/////////////////////////////////////////////////////////////////////////////
void CCFAH_WinTestDlg::OnRwL() 
  {
  control_register&=~0x02;
  Update_Buttons_From_Control_Register();
  }
/////////////////////////////////////////////////////////////////////////////
void CCFAH_WinTestDlg::OnRsH() 
  {
  control_register|=0x04;
  Update_Buttons_From_Control_Register();
  }
/////////////////////////////////////////////////////////////////////////////
void CCFAH_WinTestDlg::OnRsL() 
  {
  control_register&=~0x04;
  Update_Buttons_From_Control_Register();
  }
/////////////////////////////////////////////////////////////////////////////
void CCFAH_WinTestDlg::OnE1H() 
  {
  control_register|=0x08;
  Update_Buttons_From_Control_Register();
  }
/////////////////////////////////////////////////////////////////////////////
void CCFAH_WinTestDlg::OnE1L() 
  {
  control_register&=~0x08;
  Update_Buttons_From_Control_Register();
  }
/////////////////////////////////////////////////////////////////////////////
